﻿using CSCreateLowIntegrityProcess;
using System;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace PrintScreenNotification
{
    public partial class Form1 : Form
    {
        //ファイル書き込みチェック用プログラムからの戻り値取得用
        //DllImportのファイル名と定義
        [DllImport("kernel32.dll")]
        internal static extern uint WaitForSingleObject(IntPtr hHandle, uint dwMilliseconds);

        [DllImport("kernel32.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        static extern bool GetExitCodeProcess(IntPtr hProcess, out uint lpExitCode);
        //------------------------------------------------------

        string fimgpaths = Path.GetTempPath() + "PrintScreenNotification_Images.png";
        string SaveTime = "";
        uint lpExitCode = 0;

        public Form1()
        {
            InitializeComponent();
        }

        //キーが押されたときに呼び出される
        private void keyboardHook1_KeyboardHooked(object sender, HongliangSoft.Utilities.Gui.KeyboardHookedEventArgs e)
        {

            //トーストを表示するキーを設定
            //設定テキストボックスにフォーカスがあるとき
            if (textBox2.Focused)
            {
                textBox2.Text = e.KeyCode.ToString();
            }
            else
            {
                //押したキーがトースト表示キーの場合
                if (e.KeyCode.ToString() == textBox2.Text)
                {
                    if (e.KeyCode.ToString() == "PrintScreen")
                    {
                        if (e.UpDown.ToString() == "Down")
                        {
                            //トースト上で「保存」ボタンを押したときに保存されるファイル名
                            //をPrintScreenキーを押した日付に変える
                            SaveTime = DateTime.Now.ToString("yyyy-MM-dd_HH-mm-ss");
                            Microsoft.Win32.RegistryKey regkey = Microsoft.Win32.Registry.CurrentUser.CreateSubKey(@"Software\PrintScreenNotification", true);
                            regkey.SetValue("LastTime", SaveTime, Microsoft.Win32.RegistryValueKind.String);
                            regkey.Close();
                        }
                    }
                    if (e.UpDown.ToString() == "Up")
                    {
                        //既定の保存場所が設定されている場合
                        if (textBox1.Text != Properties.Resources.SetDefaultLocation)
                        {
                            //クリップボードから画像取得
                            Image img = System.Windows.Forms.Clipboard.GetImage();
                            //トースト通知表示キーを押したときに発動
                            //「アプリやその他の送信者からの通知を取得する」のチェック
                            Microsoft.Win32.RegistryKey regkey = Microsoft.Win32.Registry.CurrentUser.CreateSubKey(@"Software\Microsoft\Windows\CurrentVersion\PushNotifications", false);
                            int ToastEnabled = (int)regkey.GetValue("ToastEnabled",1);
                            regkey.Close();

                            //OSバージョンチェック
                            Microsoft.Win32.RegistryKey regkey2 = Microsoft.Win32.Registry.LocalMachine.CreateSubKey(@"SOFTWARE\Microsoft\Windows NT\CurrentVersion", false);
                            int WinVer = (int)regkey2.GetValue("CurrentMajorVersionNumber", 1);
                            regkey2.Close();

                            //トースト通知が無効になっている場合
                            if (ToastEnabled == 0 || WinVer != 10)
                            {
                                //Form2が存在していたらForm2を強制終了
                                if (Application.OpenForms.OfType<Form2>().Count() == 1)
                                {
                                    Application.OpenForms.OfType<Form2>().First().Close();
                                }
                                //処理待ち待機
                                Application.DoEvents();
                                //Form2を表示
                                Form2 form2 = new Form2();
                                form2.Show();
                            }
                            else
                            {
                                //クリップボードに画像が存在する場合
                                if (img != null)
                                {
                                    //ファイルの存在をチェック
                                    int fileuse = 0;
                                    if (File.Exists(fimgpaths))
                                    {
                                        //ファイルが開かれていない場合
                                        if (IsFileLocked(fimgpaths))
                                        {
                                            //ファイルが開かれているとエラー
                                            MessageBox.Show(fimgpaths + Properties.Resources.FileErr);
                                            fileuse = 1;
                                        }
                                    }
                                    //ファイルが開かれていないとき
                                    if (fileuse == 0)
                                    {
                                        //自動保存が有効
                                        if (Checkbox_AutoSave.Checked)
                                        {
                                            string imgfile = textBox1.Text + "\\" + SaveTime + "." + listBox1.SelectedItem;
                                            //ファイルの存在をチェック
                                            if (File.Exists(imgfile))
                                            {
                                                //ファイルが開かれていない場合
                                                if (!IsFileLocked(imgfile))
                                                {
                                                    img.Save(imgfile);
                                                }
                                            }
                                            else
                                            {
                                                img.Save(imgfile);
                                            }

                                            //※トーストを表示しないがチェックされて「いないとき」
                                            if (!Checkbox_NoShowToast.Checked)
                                            {
                                                img.Save(fimgpaths, System.Drawing.Imaging.ImageFormat.Png);
                                                //処理待ち待機
                                                Application.DoEvents();
                                                System.Diagnostics.Process p = System.Diagnostics.Process.Start("PrintScreenNotificationCore.exe", "1");
                                                p.WaitForExit();
                                            }
                                        }
                                        else
                                        {
                                            //自動保存が無効
                                            img.Save(fimgpaths, System.Drawing.Imaging.ImageFormat.Png);
                                            //処理待ち待機
                                            Application.DoEvents();
                                            System.Diagnostics.Process p = System.Diagnostics.Process.Start("PrintScreenNotificationCore.exe", "1");
                                            p.WaitForExit();
                                        }
                                    }
                                }
                                if (img != null)
                                {
                                    img.Dispose();
                                }
                            }
                        }
                    }
                }
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            Microsoft.Win32.RegistryKey regkey = Microsoft.Win32.Registry.CurrentUser.CreateSubKey(@"Software\PrintScreenNotification", false);
            listBox1.SelectedIndex = (int)regkey.GetValue("SaveExt", 3); //拡張子インデックス
            Checkbox_AutoSave.Checked = System.Convert.ToBoolean(regkey.GetValue("AutoSave", false)); //自動保存
            Checkbox_NoShowToast.Checked = System.Convert.ToBoolean(regkey.GetValue("NoShowToast", false)); //自動保存でトーストを表示しない
            textBox1.Text = (string)regkey.GetValue("Directory", Properties.Resources.SetDefaultLocation); //保存場所
            textBox2.Text = (string)regkey.GetValue("ToastKey", "PrintScreen"); //トースト表示キー
            regkey.Close();

            //既定の保存場所が設定されていないときに初期化メッセージ表示
            if (textBox1.Text == Properties.Resources.SetDefaultLocation)
            {
                MessageBox.Show(Properties.Resources.Initialize, "Information",MessageBoxButtons.OK,MessageBoxIcon.Information,MessageBoxDefaultButton.Button1,MessageBoxOptions.DefaultDesktopOnly);
            }
        }

        //フォームが閉じられるとき
        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            notifyIcon1.Visible = false;
        }

        //OKボタンを押すと最小化
        private void button1_OK_Click(object sender, EventArgs e)
        {
            Visible = false;
            this.WindowState = FormWindowState.Minimized;
        }

        //保存フォルダを開く
        private void button_Open_Click(object sender, EventArgs e)
        {
            //保存場所が設定されてるとき
            if (textBox1.Text != Properties.Resources.SetDefaultLocation)
            {
                System.Diagnostics.Process.Start(textBox1.Text);
            }

        }

        //通知領域アイコンをダブルクリックすると
        //最小化状態を解除してウィンドウをアクティブにする
        private void notifyIcon1_DoubleClick(object sender, EventArgs e)
        {
            this.Visible = true;
            this.WindowState = FormWindowState.Normal;
            this.Activate();
        }

        //通知領域アイコンから終了した場合の処理
        private void ExitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            System.Windows.Forms.Application.Exit();
        }

        //フォームが表示されたとき
        private void Form1_Shown(object sender, EventArgs e)
        {
            //保存場所が設定されていないとき
            if (textBox1.Text == Properties.Resources.SetDefaultLocation)
            {
                //ウィンドウを通常表示にする
                this.WindowState = FormWindowState.Normal;
            }
            else
            {
                Visible = false;
            }

        }

        //チェックボックス「自動保存が有効」の時
        private void Checkbox_AutoSave_CheckedChanged(object sender, EventArgs e)
        {
            //チェック状態を変更
            if (Checkbox_AutoSave.Checked)
            {
                Checkbox_AutoSave.Checked = true;
            }
            else
            {
                Checkbox_AutoSave.Checked = false;
            }
        }

        //FormUI上の既定の保存場所を押したとき
        //保存場所を設定するダイアログを開く
        private void button3_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog fd = new FolderBrowserDialog();
            if (fd.ShowDialog() == DialogResult.OK)
            {
                //選択したフォルダに正常に書き込めるかどうかをテスト
                CreateMidIntegrityProcess("PrintScreenNotificationCore.exe 2 \"" + fd.SelectedPath + "\"");

                //通常に書き込めると返り値があった時
                if (lpExitCode == 0)
                {
                    textBox1.Text = fd.SelectedPath;
                }
                else
                {
                    //フォルダが設定できなかったと表示する
                    MessageBox.Show(Properties.Resources.SetErrDir);
                }
            }
            fd.Dispose();
        }
        //タスクトレイの設定ボタンを押したとき
        //タスクトレイから戻し、最小化されている場合は通常表示
        private void SettingToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (this.Visible == true)
            {
                this.WindowState = FormWindowState.Minimized;
            }
            else
            {
                this.Visible = true;
                if (this.WindowState == FormWindowState.Minimized)
                {
                    this.WindowState = FormWindowState.Normal;
                }
                this.Activate();
            }
        }

        //ウィンドウが非アクティブになった時にレジストリに値を書き込む
        private void Form1_Deactivate(object sender, EventArgs e)
        {
            Microsoft.Win32.RegistryKey regkey = Microsoft.Win32.Registry.CurrentUser.CreateSubKey(@"Software\PrintScreenNotification", true);
            regkey.SetValue("SaveExt", listBox1.SelectedIndex); //拡張子インデックス
            regkey.SetValue("AutoSave", Checkbox_AutoSave.Checked); //自動保存が有効かどうか
            regkey.SetValue("NoShowToast", Checkbox_NoShowToast.Checked); //自動保存が有効かどうか
            regkey.SetValue("Directory", textBox1.Text, Microsoft.Win32.RegistryValueKind.String); //保存場所
            regkey.SetValue("ToastKey", textBox2.Text, Microsoft.Win32.RegistryValueKind.String); //トースト表示キー
            regkey.Close();
        }

        //通常ユーザで起動するためのプロセス生成
        internal void CreateMidIntegrityProcess(string commandLine)
        {
            SafeTokenHandle hToken = null;
            SafeTokenHandle hNewToken = null;
            IntPtr pIntegritySid = IntPtr.Zero;
            int cbTokenInfo = 0;
            IntPtr pTokenInfo = IntPtr.Zero;
            STARTUPINFO si = new STARTUPINFO();
            PROCESS_INFORMATION pi = new PROCESS_INFORMATION();

            try
            {
                // Open the primary access token of the process.
                if (!NativeMethod.OpenProcessToken(Process.GetCurrentProcess().Handle,
                    NativeMethod.TOKEN_DUPLICATE | NativeMethod.TOKEN_ADJUST_DEFAULT |
                    NativeMethod.TOKEN_QUERY | NativeMethod.TOKEN_ASSIGN_PRIMARY,
                    out hToken))
                {
                    throw new Win32Exception();
                }

                // Duplicate the primary token of the current process.
                if (!NativeMethod.DuplicateTokenEx(hToken, 0, IntPtr.Zero,
                    SECURITY_IMPERSONATION_LEVEL.SecurityImpersonation,
                    TOKEN_TYPE.TokenPrimary, out hNewToken))
                {
                    throw new Win32Exception();
                }

                // Create the low integrity SID.
                if (!NativeMethod.AllocateAndInitializeSid(
                    ref NativeMethod.SECURITY_MANDATORY_LABEL_AUTHORITY, 1,
                    NativeMethod.SECURITY_MANDATORY_MEDIUM_RID,
                    0, 0, 0, 0, 0, 0, 0, out pIntegritySid))
                {
                    throw new Win32Exception();
                }

                TOKEN_MANDATORY_LABEL tml;
                tml.Label.Attributes = NativeMethod.SE_GROUP_INTEGRITY;
                tml.Label.Sid = pIntegritySid;

                // Marshal the TOKEN_MANDATORY_LABEL struct to the native memory.
                cbTokenInfo = Marshal.SizeOf(tml);
                pTokenInfo = Marshal.AllocHGlobal(cbTokenInfo);
                Marshal.StructureToPtr(tml, pTokenInfo, false);

                // Set the integrity level in the access token to low.
                if (!NativeMethod.SetTokenInformation(hNewToken,
                    TOKEN_INFORMATION_CLASS.TokenIntegrityLevel, pTokenInfo,
                    cbTokenInfo + NativeMethod.GetLengthSid(pIntegritySid)))
                {
                    throw new Win32Exception();
                }

                // Create the new process at the Low integrity level.
                si.cb = Marshal.SizeOf(si);
                if (!NativeMethod.CreateProcessAsUser(hNewToken, null, commandLine,
                    IntPtr.Zero, IntPtr.Zero, false, 0, IntPtr.Zero, null, ref si,
                    out pi))
                {
                    throw new Win32Exception();
                }

                // Wait Process Exit
                if (WaitForSingleObject(pi.hProcess, 100000) == 0)
                {
                    GetExitCodeProcess(pi.hProcess, out lpExitCode);
                }
            }
            finally
            {
                // Centralized cleanup for all allocated resources. 
                if (hToken != null)
                {
                    hToken.Close();
                    hToken = null;
                }
                if (hNewToken != null)
                {
                    hNewToken.Close();
                    hNewToken = null;
                }
                if (pIntegritySid != IntPtr.Zero)
                {
                    NativeMethod.FreeSid(pIntegritySid);
                    pIntegritySid = IntPtr.Zero;
                }
                if (pTokenInfo != IntPtr.Zero)
                {
                    Marshal.FreeHGlobal(pTokenInfo);
                    pTokenInfo = IntPtr.Zero;
                    cbTokenInfo = 0;
                }
                if (pi.hProcess != IntPtr.Zero)
                {
                    NativeMethod.CloseHandle(pi.hProcess);
                    pi.hProcess = IntPtr.Zero;
                }
                if (pi.hThread != IntPtr.Zero)
                {
                    NativeMethod.CloseHandle(pi.hThread);
                    pi.hThread = IntPtr.Zero;
                }
            }
        }

        /// <summary>
        /// 指定されたファイルがロックされているかどうかを返します。
        /// </summary>
        /// <param name="path">検証したいファイルへのフルパス</param>
        /// <returns>ロックされているかどうか</returns>
        private bool IsFileLocked(string path)
        {
            FileStream stream = null;

            try
            {
                stream = new FileStream(path, FileMode.Open, FileAccess.ReadWrite, FileShare.None);
            }
            catch
            {
                return true;
            }
            finally
            {
                if (stream != null)
                {
                    stream.Close();
                }
            }

            return false;
        }
    }
}
